﻿import es
import gamethread
import playerlib
import usermsg

info = es.AddonInfo() 
info.name = 'Reinforcement Waves'
info.version = '1.0.4'
info.url = 'http://forums.mattie.info/cs/forums/viewtopic.php?t=24760'
info.basename = 'reinforcement_waves'
info.author = 'Sc0pE'
es.ServerVar('reinforcement_waves_ver',info.version,'Reinforcement Waves By: Sc0pE').makepublic()
######### DO NOT EDIT ABOVE THIS LINE! ########### 

# The time between TERRORIST respawn waves
t_respawn_rate = 25

# The time between COUNTER-TERRORIST respawn waves
ct_respawn_rate = 25

# --------Static Reinforcements Number-----------------------------------------------
#
# The number of TERRORIST reinforcements
t_reinforcements_number = 30

# The number of COUNTER-TERRORIST reinforcements
ct_reinforcements_number = 30
# ------------------------------------------------------------------------------------------------

# -----Multiplying Reinforcements Number---------------------------------------------
#
# Uses this multiplier to set the number of reinforcements per team (resets at the start of each round)
# **This will override the t_reinforcements_number and ct_reinforcements_number (above^^)**
# If set to 4 and there are five terrorists playing (for example) there will be 20 reinforcments for terrorists that round
# 0 = Disabled
reinforcements_multiplier = 0
# ------------------------------------------------------------------------------------------------

# If all reinforcement spawning should end once the bomb is planted
bomb_plant_end = 1

# The ammount of time you are protected after spawning
# 0 = Disabled
spawn_protection = 2

# Ammount of time to freeze the player when they spawn
# 0 = Disabled
freeze_time = 2

# The ammount of cash the player has when they spawn
cash_amount = 4000

# Dissolve the player's body when they die instead of just deleting their body?
dissolver = 1

######### DO NOT EDIT BELOW THIS LINE! ########### 

t_wave_remaining = None
ct_wave_remaining = None
t_reinforcements = None
ct_reinforcements = None
enabled = 1

def load():
    es.server.queuecmd('mp_restartgame 2')
    gamethread.delayed(2, resetAll)
    es.msg('#multi', '#green[#lightgreenReinforcement Waves#green]#default Loaded')

def unload():
    gamethread.cancelDelayed('waveRepeat_delay')
    es.msg('#multi', '#green[#lightgreenReinforcement Waves#green]#default Unloaded')

def resetAll():
    global t_reinforcements, ct_reinforcements, t_wave_remaining, ct_wave_remaining
    if reinforcements_multiplier:
        t_reinforcements  = es.getplayercount(2) * reinforcements_multiplier
        ct_reinforcements = es.getplayercount(3) * reinforcements_multiplier
    else:
        t_reinforcements  = t_reinforcements_number
        ct_reinforcements = ct_reinforcements_number
    t_wave_remaining  = t_respawn_rate
    ct_wave_remaining = ct_respawn_rate
    gamethread.cancelDelayed('waveRepeat_delay')
    waveRepeat()

def waveRepeat():
    global t_wave_remaining, ct_wave_remaining, t_reinforcements, ct_reinforcements
    for userid in es.getUseridList():
        if enabled:
            usermsg.hudhint(userid, 'Reinforcements:\n T:%s\nCT:%s' % (t_reinforcements, ct_reinforcements))
            if playerlib.getPlayer(userid).get('isdead'):
                team = es.getplayerteam(userid)
                if team == 2:
                    if t_reinforcements > 0:
                        es.centertell(userid, 'Time until respawn: %s' % t_wave_remaining)
                        if t_wave_remaining < 1:
                            t_reinforcements -= 1
                            es.server.queuecmd('est_spawn %s' % userid)
                elif team == 3:
                    if ct_reinforcements > 0:
                        es.centertell(userid, 'Time until respawn: %s' % ct_wave_remaining)
                        if ct_wave_remaining < 1:
                            ct_reinforcements -= 1
                            es.server.queuecmd('est_spawn %s' % userid)
        else:
            usermsg.hudhint(userid, 'Reinforcements:\nBomb Planted\nReinforcements Disabled')
    if t_wave_remaining < 1:
        if t_reinforcements > 0:
            t_wave_remaining = t_respawn_rate
    if ct_wave_remaining < 1:
        if ct_reinforcements > 0:
            ct_wave_remaining = ct_respawn_rate
    t_wave_remaining -= 1
    ct_wave_remaining -= 1
    gamethread.delayedname(1, 'waveRepeat_delay', waveRepeat)

def player_death(ev):
    userid = int(ev['userid'])
    if dissolver:
        es.server.cmd('es_xgive %s env_entity_dissolver' % userid)
        es.server.cmd('es_xfire %s env_entity_dissolver AddOutput "target cs_ragdoll"' % userid)
        es.server.cmd('es_xfire %s env_entity_dissolver AddOutput "magnitude 1"' % userid)
        es.server.cmd('es_xfire %s env_entity_dissolver AddOutput "dissolvetype 3"' % userid)
        es.delayed('0.01', 'es_xfire %s env_entity_dissolver Dissolve' % userid)
        es.delayed('4', 'es_xfire %s env_entity_dissolver Kill' % userid)
        es.delayed('4', 'es_xfire %s cs_ragdoll Kill' % userid)
    else:
        es.delayed('2', 'es_xfire %s cs_ragdoll Kill' % userid)
    es.server.queuecmd('est_RemoveIdle weapon')
    for item in es.createentitylist('item_defuser'):
        if es.getindexprop(item, 'CBaseEntity.m_hOwnerEntity') == es.getplayerhandle(userid):
            es.server.queuecmd('es_xremove %s' % item)

def player_spawn(ev):
    userid = int(ev['userid'])
    if freeze_time:
        gamethread.delayed(0.3, es.setplayerprop, (userid, "CBaseEntity.movetype", '0'))
        gamethread.delayed(freeze_time, es.setplayerprop, (userid, "CBaseEntity.movetype", '2'))
    if spawn_protection:
        es.server.queuecmd('est_god %d 1' % userid)
        es.server.queuecmd('est_setplayercolor %d 255 75 75 100 1' % userid)
        gamethread.delayed(spawn_protection, es.server.queuecmd, ('est_god %d 0' % userid))
        gamethread.delayed(spawn_protection, es.server.queuecmd, ('est_setplayercolor %d 255 255 255 255 1' % userid))
    es.setplayerprop(userid, "CCSPlayer.m_iAccount", cash_amount)

def player_team(ev):
    global t_reinforcements, ct_reinforcements
    if reinforcements_multiplier:
        t_temp = (es.getplayercount(2) * reinforcements_multiplier)
        if ev['oldteam'] == '2' and t_reinforcements > t_temp:
            t_reinforcements = t_temp
            es.msg('#multi', '#green[#lightgreenReinforcement Waves#green]#lightgreen Terrorist#default reinforcments were set to #green%d#default due to a player leaving' % t_temp)
        ct_temp = (es.getplayercount(3) * reinforcements_multiplier)
        if ev['oldteam'] == '3' and ct_reinforcements > ct_temp:
            ct_reinforcements = ct_temp
            es.msg('#multi', '#green[#lightgreenReinforcement Waves#green]#lightgreen Counter-Terrorist#default reinforcments were set to #green%d#default due to a player leaving' % ct_temp)
        if ev['team'] == '2' and t_reinforcements >= reinforcements_multiplier:
            t_reinforcements += reinforcements_multiplier
            es.msg('#multi', '#green[#lightgreenReinforcement Waves#green]#lightgreen Terrorists#default gained #green%d#default reinforcments due to a player joining their team' % reinforcements_multiplier)
        if ev['team'] == '3' and ct_reinforcements >= reinforcements_multiplier:
            ct_reinforcements += reinforcements_multiplier
            es.msg('#multi', '#green[#lightgreenReinforcement Waves#green]#lightgreen Counter-Terrorists#default gained #green%d#default reinforcments due to a player joining their team' % reinforcements_multiplier)

def bomb_planted(ev):
    global enabled
    if bomb_plant_end:
        enabled = 0

def round_start(ev):
    global enabled
    enabled = 1
    resetAll()